package tanzaku;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GraphicsEnvironment;
import java.awt.Insets;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;
import javax.swing.SwingUtilities;

import tanzaku21.Zoom;

public class HorizontalWriting extends JFrame implements ActionListener {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	int main_panel_higth = 0;
	String kabuse_haba;
	String h_ue_haba= null;

	int h = 0;
	int line_top_y;
	int line_bottom_y;

	JButton button = new JButton();

	boolean flag = true;// 検索開始は白なので、黒を最初に検索開始

	// 全体を黒と白に分ける
	int brack_count = 0;// 黒カウント
	int non_brack_count = 0;
	int white_count = 0;// 白カウント
	int non_white_count = 0;

	BufferedImage readImage = null;

	JPanel main_panel = new JPanel(new FlowLayout(0, 1, 1));

	JButton control = new JButton("10");

	// RGB;-1の時は黒
	// RGB;-16777215の時は白
	int Boundary_of_the_RGB_black_and_white = -3000000;// 黒のカウントの境界値

	// String filename;//読み込みファイル名
	double boundaries_of_the_percentage_of_RGB_white = 0.05D;// 5％
	double boundaries_of_the_percentage_of_RGB_brack = 0.99D;

	int height = 0;

	int split = 0;// :倍率

	int verchal_scrol_widht = 20;

	int frame_width = 0;

	public HorizontalWriting(String path, int magnification) {
		//
		// try {
		// for (LookAndFeelInfo info : UIManager.getInstalledLookAndFeels()) {
		// if ("Nimbus".equals(info.getName())) {
		// UIManager.setLookAndFeel(info.getClassName());
		// break;
		// }
		// }
		// } catch (Exception e) {
		// // If Nimbus is not available, you can set the GUI to another look
		// and feel.
		// }

		SwingUtilities.updateComponentTreeUI(this);

		Properties prop = new Properties();
		try {
			prop.load(new FileInputStream("./resource/prop1.properties"));
		} catch (FileNotFoundException e1) {

			e1.printStackTrace();
		} catch (IOException e1) {

			e1.printStackTrace();
		}

		kabuse_haba = prop.getProperty("kabuse_haba");
		h_ue_haba = prop.getProperty("h_ue_haba");

		System.out.println("kabuse_haba:" + kabuse_haba);

		// int lateral_margin = Lateral_margin.lateral_margin(path);
		int lateral_margin = 0;

		GraphicsEnvironment env = GraphicsEnvironment
				.getLocalGraphicsEnvironment();
		Rectangle rect = env.getMaximumWindowBounds();

		System.out.println("frame_width：" + frame_width);

		File file = new File(path);

		// filename = file.getName();

		System.out.println("path==" + path);
		// System.out.println("filename==" + filename);

		try {
			readImage = ImageIO.read(new File(path));
		} catch (Exception e) {
			e.printStackTrace();
			readImage = null;
		}

		int width = readImage.getWidth();
		height = readImage.getHeight();
		int[] rgbArray = new int[width * height];
		int offset = 0;
		int scansize = width;

		/******** 倍率設定 *********/
		// int split = frame_width / width;// :倍率
		split = magnification;// :倍率

		System.out.println("split==" + split);
		/*****************/

		readImage.getRGB(0, 0, width, height, rgbArray, offset, scansize);// ここでRGBを全て取得する。

		for (int x = 0; x < width; x++) {
			// System.out.print(String.format("%1$2d", x));
		}

		System.out.println();

		for (int y = 0; y < height; y++) {

			// System.out.print(String.format("【%1$4d】 ", y));
			// System.out.println(" ");

			int x;
			for (x = 0; x < width; x++) {

				int pixel = rgbArray[y * width + x];// 現在位置のドット
				Color c = new Color(pixel);

				// System.out.println("getRGB:"+c.getRGB()*(-1));
				// System.out.print(String.format("%1$9d", c.getRGB()));
				// System.out.print(String.format("%1$3d", c.getRed()));
				// System.out.print(" ");
				// System.out.print(String.format("%1$3d", c.getGreen()));
				// System.out.print(" ");
				// System.out.print(String.format("%1$3d", c.getBlue()));

				if (flag) {// 検索開始は白なので、黒を最初に検索開始

					// if (r < 50& g < 50 & b < 50)
					// {//黒に近いRGBInteger.toHexString(pixel)
					// if ((int)Integer.decode(Integer.toHexString(pixel))>
					// (int)Integer.decode("000000")) {//黒に近いRGB
					// if (c.getRed()==0&c.getBlue()==0&c.getGreen()==0) {//
					// 黒に近いRGBInteger.toHexString(pixel)
					if (pixel * (-1) > (Boundary_of_the_RGB_black_and_white * (-1))) {// 黒に近いRGBInteger.toHexString(pixel)

						brack_count++;

						// System.out.print(String.format("[%1$3d]",
						// brack_count));

						// System.out.print("黒");
					} else {

						non_brack_count++;

						// System.out.print(String.format("[%1$3d]",
						// non_brack_count));

						// System.out.print("白");
					}

					// System.out.print("");

					if (brack_count > (width * boundaries_of_the_percentage_of_RGB_white)) {// 黒行を発見（60％）
						//
						// System.out.println();
						// System.out.println();
						// System.out.print("■brack_count:" + brack_count + "  "
						// +
						// (int) brack_count
						// * 100 / width + "％");
						//
						// System.out.print(" ■line_top_y:" + line_top_y +
						// " line_bottom_y:"
						// + line_bottom_y);
						// System.out.println();

						// System.out.println(" 白行検索開始 brack_count："+brack_count+" y_top:"+y_top+" y_bottom:"+y_bottom);

						line_top_y = y - Integer.parseInt(h_ue_haba);// 検索結果の1行手前を、画像切り取りtopとする

						flag = false;// 黒行、文字列に入ったため、白行まで探索

						break;
					}

				} else {

					// if (c.getRed()==255&c.getBlue()==255&c.getGreen()==255) {
					if (pixel * (-1) < (Boundary_of_the_RGB_black_and_white * (-1))) {
						// if (r > 200 & g > 200 & b > 200) {//白に近いRGB
						// if ((int)Integer.decode(Integer.toHexString(pixel))<
						// (int)Integer.decode("000000")) {//白に近いRGB

						white_count++;

						// System.out.print(String.format("[%1$3d]",
						// white_count));

						// System.out.print("白");

					} else {
						non_white_count++;

						// System.out.print(String.format("[%1$3d]",
						// non_white_count));

						// System.out.print("黒");
					}

					// System.out.print("");

					if (white_count > width
							* boundaries_of_the_percentage_of_RGB_brack) {

						// System.out.println(" 黒行検索開始【切断】white_count："+white_count+" y_top:"+y_top+" y_bottom:"+y_bottom);
						// System.out.println();
						// System.out.println();
						// System.out.println("width * boundaries_of_the_percentage_of_RGB_brack=="+width
						// * boundaries_of_the_percentage_of_RGB_brack);
						// System.out.print("□white_count(" + white_count +
						// ") > width * boundaries_of_the_percentage_of_RGB_brack("
						// + width *
						// boundaries_of_the_percentage_of_RGB_brack+")");
						// System.out.print(" □line_top_y:" + line_top_y +
						// " line_bottom_y:"
						// + line_bottom_y);
						// System.out.println();

						white_count = 0;
						non_white_count = 0;

						line_bottom_y = y + Integer.parseInt(h_ue_haba);

						/******** 分割→拡大 *******/

						for (int j = split, i = 1; i <= split; i++, j--) {

							// int button_width = width
							// * split
							// + (rect.height - (width - verchal_scrol_widht)
							// * split) + 30;

//							System.out.println("-------------------");
//							System.out.println("a;"+(double)((double)width));
//							System.out.println("a;"+(double)((double)rect.width));
//							System.out.println("a;"+(double)((double)rect.width/(double)width));

							Zoom zoom = new Zoom(readImage, //
															// ボタンに乗せる画像
									0, //
									0, //
										// 5: 上下のpicel増分加算

									rect.width - 33,// 55:スクロールペインのデフォルトバーの幅
									(int)((line_bottom_y - line_top_y) * split*(double)((double)rect.width/(double)width)),

									// 元の画像
									(int) (width - (width * (j / (double) split)))
											+ lateral_margin
											- Integer.parseInt(kabuse_haba),// +(line_bottom_y-line_top_y):一文字かぶせる
									line_top_y,//
									(int) ((width * (i / (double) split))), //
									line_bottom_y);

							/********* ソース画像サイズ **********/
							// System.out.print("ソース画像サイズ:");
							// System.out.print(" sx："
							// + String.format("%1$2d",
							// (int) (width - (width * (j / (double) split)))));
							// System.out.print(" sy：" + String.format("%1$2d",
							// line_top_y));
							// System.out
							// .print("　sw："
							// + String.format("%1$2d",
							// (int) ((width * (i / (double) split)))));
							// System.out.println(" sh：" +
							// String.format("%1$2d", line_bottom_y));
							/*******************/

							/********* 表示画像サイズ **********/
							// System.out.print("表示画像サイズ　:");
							// System.out.print(" sx：" + String.format("%1$2d",
							// 0));
							// System.out.print(" sy：" + String.format("%1$2d",
							// 0));
							// System.out.print("　sw：" + String.format("%1$2d",
							// width * split));
							// System.out.println(" sh："
							// + String.format("%1$2d", (line_bottom_y * split -
							// line_top_y
							// * split)
							// * split));
							/*******************/

							// System.out.println();

							button = new JButton();

							int scrol_width = 30;
							frame_width = rect.height;// 正方形より少し、横長

							// button.setPreferredSize(new Dimension(
							// width
							// * split
							// + (rect.height - (width - verchal_scrol_widht)
							// * split) + scrol_width,
							// (line_bottom_y - line_top_y) * split + 5));

							button.setPreferredSize(new Dimension(
									rect.width - 33,
									(int)((line_bottom_y - line_top_y) * split*(double)((double)rect.width/(double)width))));

							main_panel_higth += (int)((line_bottom_y - line_top_y) * split*(double)((double)rect.width/(double)width))+1;

							button.setBackground(Color.white);
							button.setMargin(new Insets(0, 0, 0, 0));
							button.setBorderPainted(false);
							button.setOpaque(true);
							button.add(zoom);

							main_panel.add(button);

							// h = (line_bottom_y - line_top_y ) * split+h;
						}

						/******************/

						flag = true;// 白行、文字列に入ったため、黒行まで探索

						break;
					}
				}

				// if(pixel<-60000){//白
				// System.out.print(String.format("%1$1d", 0));
				// }else{//黒
				// System.out.print(String.format("%1$1d", 1));
				// }
				// System.out.print("(" + x + "," + y + ")=" + pixel + " ");
				// System.out.print(String.format("%1$9d", pixel));

			}

			// if (blackCount == 64000) {
			// System.out.println("break y");
			// break; // loop y
			//
			// }

			// System.out.print("\n                                                    【");
			// System.out.print(String.format("白検索(白%1$2d ", white_count));
			// System.out.print(String.format("黒%1$2d)", non_white_count));
			//
			// System.out.print(String.format("    黒検索(黒%1$2d ", brack_count));
			// System.out.print(String.format("白%1$2d)】", non_brack_count));

			white_count = 0;
			non_white_count = 0;

			brack_count = 0;
			non_brack_count = 0;

		}

		JScrollPane scrollpane = new JScrollPane(main_panel);
		// scrollpane.getVerticalScrollBar().setUnitIncrement(1000);
		scrollpane.setPreferredSize(new Dimension(frame_width
				- verchal_scrol_widht, 0));

		// JScrollBar jScrollBar = new JScrollBar();
		// jScrollBar.setPreferredSize(new Dimension(scroleber_width, 0));
		// jScrollBar.setBackground(Color.black);
		// jScrollBar.setForeground(Color.white);
		//
		// jScrollBar.setBlockIncrement(rect.height - 200);
		// //横ｽｸﾛｰﾙﾊﾞｰのつまみ("サム")をドラッグした場合の移動量
		// jScrollBar.setUnitIncrement(rect.height - 200);
		// //横ｽｸﾛｰﾙﾊﾞｰの左右矢印ボタンをクリックした場合の移動量

		// JScrollBar.set

		// scrollpane.setVerticalScrollBar(jScrollBar);
		scrollpane
				.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);

		control.addActionListener(this);

		this.setLayout(new BorderLayout());
		this.add(scrollpane, BorderLayout.CENTER);
		// this.add(control,BorderLayout.EAST);
		ImageIcon icon = new ImageIcon("./resource/img/tanzaku21.jpg");
		this.setIconImage(icon.getImage());
		this.setTitle(path + "【" + split + "倍】");

		// g.drawImage(readImage, 0, 50, pct_width*4, (y_bottom*4+50), 0, y_top,
		// pct_width, y_bottom-y_top, this);

		// this.setBounds(0, 0, width * split
		// + (frame_width - (width - verchal_scrol_widht) * split) + 50,
		// rect.height);

		this.setBounds(0, 0, rect.width, rect.height);

		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);

		main_panel.setPreferredSize(new Dimension(frame_width
				- verchal_scrol_widht, main_panel_higth));
		main_panel.setBackground(new Color(220,220,220));

		// System.out.println("height * split::" + height * split * 15);

		this.setVisible(true);
		main_panel_higth = 0;
	}

	public static void main(String[] args) throws Exception {
		// new tanzaku21_Horizontal_writing(
		// "C:/11_workspace_timecard/tasuki21/test201205200001.jpg",//
		// 2//
		// );
		new HorizontalWriting(
		// "/Users/apple/Documents/workspace/tqnzaku21/Image/入門経済学　スティグリッツ-01/入門経済学　スティグリッツ-010010.jpg",//
				"/Users/apple/Documents/workspace/tqnzaku21/Image/入江pdf/入門経済学　スティグリッツ-010010.jpg",//
				20//
		);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		// if(e.getSource()==){
		// Magnification =
		// }
	}
}