package tanzaku;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.imageio.ImageIO;

public class Jpg_tate_renketu_ {

	public static void main(String[] args) throws Exception {
		jpg_ketugou(//
				"c:/11_workspace_timecard/tasuki21/Image/入門経済学　スティグリッツ-01/入門経済学　スティグリッツ-010001.jpg"//
				, "c:/11_workspace_timecard/tasuki21/Image/入門経済学　スティグリッツ-01"//
				,"入門経済学　スティグリッツ-010001.jpg"//
				,5//
				,15+1//
		);
	}

	public static int jpg_ketugou(//
			String file_path, //
			String folder_path,//
			String file_name,//
			int start_page,//
			int end_page//
	) throws IOException {

		try {
			BufferedImage image = null;
			BufferedImage image2;

			System.out.println("---------------------------");
			System.out.println("file_path: "+file_path );
			System.out.println("folder_path: "+folder_path );
			System.out.println("file_name: "+file_name );
			System.out.println("start_page: "+start_page );
			System.out.println("end_page: "+end_page );

			image2 = ImageIO.read(new File(file_path));

			int height = image2.getHeight();
			int width = image2.getWidth();

			image = new BufferedImage(width, height * end_page-1 - end_page, BufferedImage.TYPE_INT_BGR);

			for (int i = start_page, j = 1; i < end_page; i++, j++) {

			String str1 = getPreffix(file_name);//拡張子削除

//			System.out.println("str1.substring(0, str1.length()-1):"+str1.substring(0, str1.length()-3));
				String regex = str1.substring(0, str1.length()-3)+String.format("%03d", i);

				image2 = ImageIO.read(new File(folder_path + "/"+regex + ".jpg"));

				for (int y = 0; y < height; y++) {
					for (int x = 0; x < width; x++) {

						//0ページのエラー処理
						image.setRGB(x, y + height * (j - 1), image2.getRGB(x, y));

					}
				}
			}

			SimpleDateFormat sdf1 = new SimpleDateFormat("_yyyy年MM月dd日HH時mm分");
			ImageIO.write(image, "jpg",
					new File("./image_folder/combined_image" + sdf1.format(new Date()) + ".jpg"));

			return 1;
		} catch (Exception e) {

			e.printStackTrace();
			return 2;
		}
	}


	/**
	 * ファイル名から拡張子を取り除いた名前を返します。
	 *
	 * @param fileName
	 *            ファイル名
	 * @return ファイル名
	 */
	public static String getPreffix(String fileName) {
		if (fileName == null)
			return null;
		int point = fileName.lastIndexOf(".");
		if (point != -1) {
			return fileName.substring(0, point);
		}
		return fileName;
	}


	private static void check(Pattern p, String target) {
		Matcher m = p.matcher(target);

		if (m.find()) {
			System.out.println("○ " + target);
		} else {
			System.out.println("× " + target);
		}
	}

}