package tanzaku;

import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.JFrame;

public class ScaleJPG extends JFrame {

	public static void scale(String src, int width, int height, String dest,double shx, double shy ) throws IOException {

		BufferedImage bsrc = ImageIO.read(new File(src));
		BufferedImage bdest = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
		Graphics2D g = bdest.createGraphics();

		AffineTransform at = AffineTransform.getShearInstance(shx, shy);

		g.drawRenderedImage(bsrc, at);

		if (at != null) {
			g.setTransform(at);
		}

		//ImageIO.write(bdest, "JPG", new File(dest));
	}

	public static void main(String[] args) {

		BufferedImage readImage = null;

		String filename2 = "C:/11_workspace_timecard/tasuki21/src/tanzaku21/入門経済学　スティグリッツ0006.jpg";
		String filename = "C:/11_workspace_timecard/tasuki21/src/tanzaku21/test.jpg";

		try {
			readImage = ImageIO.read(new File(filename));
		} catch (Exception e) {
			e.printStackTrace();
			readImage = null;
		}

		int width = readImage.getWidth();
		int height = readImage.getHeight();


		try {
			ScaleJPG.scale(//
					filename, //
					width, //
					height+100,//
					filename2,//

					0.0, //
					-0.6
			);

		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}