package tanzaku;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GraphicsEnvironment;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JViewport;
import javax.swing.ScrollPaneConstants;

import tanzaku21.Zoom;

public class VerticalWriting extends JFrame implements ActionListener {

	JScrollPane scrollpane;

	static int main_panel_w = 0;
	static int main_panel_width = 0;
	static int main_panel_width_int = 0;


	JButton next_btn;
	JButton modoru_btn;
	JButton top_btn;
	JPanel ctl_button_panel;


	int line_top_x;
	int line_bottom_x;

	JButton button = new JButton();

	boolean flag = true;// 検索開始は白なので、黒を最初に検索開始

	// 全体を黒と白に分ける
	int brack_count = 0;// 黒カウント
	int non_brack_count = 0;
	int white_count = 0;// 白カウント
	int non_white_count = 0;

	BufferedImage readImage = null;

	FlowLayout layout;
	JPanel main_panel;

	JButton control = new JButton("10");

	// RGB;-1の時は黒
	// RGB;-16777215の時は白
	int Boundary_of_the_RGB_black_and_white = -3000000;// 黒のカウントの境界値

	// String filename;//読み込みファイル名
	double boundaries_of_the_percentage_of_RGB_white = 0.01D;// 5％
	double boundaries_of_the_percentage_of_RGB_brack = 0.99D;

	int height = 0;

	int split = 0;// :倍率

	int scroleber_width = 100;

	int scrol_higth = 50;

	String kabuse_haba;

	Rectangle rect;

	/**
	 * @param path
	 * @param magnification
	 */
	public VerticalWriting(String path, int magnification) {

		this.button = new JButton();
		this.next_btn = new JButton("次");
		this.modoru_btn = new JButton("戻");
		this.top_btn = new JButton("トップ");
		this.ctl_button_panel = new JPanel(new GridLayout(3,1,2,2));

		JButton next_btn = new JButton();
		JButton modoru_btn = new JButton();
		JButton top_btn = new JButton();

		next_btn.setText("次");
		modoru_btn.setText("戻");
		top_btn.setText("頭");

		next_btn.addActionListener(this);
		modoru_btn.addActionListener(this);
		top_btn.addActionListener(this);

		next_btn.setActionCommand(next_btn.getText());
		modoru_btn.setActionCommand(modoru_btn.getText());
		top_btn.setActionCommand(top_btn.getText());

		next_btn.setBackground(Color.white);
		modoru_btn.setBackground(Color.white);
		top_btn.setBackground(Color.white);

		next_btn.setMargin(new Insets(0,0,0,0));
		modoru_btn.setMargin(new Insets(0,0,0,0));
		top_btn.setMargin(new Insets(0,0,0,0));

		ctl_button_panel.setPreferredSize(new Dimension(35,0));
		ctl_button_panel.add(next_btn);
		ctl_button_panel.add(modoru_btn);
		ctl_button_panel.add(top_btn);

		Properties prop = new Properties();

		try {
			prop.load(new FileInputStream("./resource/prop1.properties"));
		} catch (FileNotFoundException e1) {

			e1.printStackTrace();
		} catch (IOException e1) {

			e1.printStackTrace();
		}
		kabuse_haba = prop.getProperty("kabuse_haba");
		System.out.println("kabuse_haba:" + kabuse_haba);

		layout = new FlowLayout(0, 1, 1);
		layout.setAlignment(FlowLayout.RIGHT);

		main_panel = new JPanel(layout);

		GraphicsEnvironment env = GraphicsEnvironment
				.getLocalGraphicsEnvironment();
		rect = env.getMaximumWindowBounds();

		File file = new File(path);

		// filename = file.getName();

		System.out.println("path==" + path);
		// System.out.println("filename==" + filename);

		try {
			readImage = ImageIO.read(new File(path));
		} catch (Exception e) {
			e.printStackTrace();
			readImage = null;
		}

		int width = readImage.getWidth();
		height = readImage.getHeight();
		int[] rgbArray = new int[width * height];
		int offset = 0;
		int scansize = width;

		/******** 倍率設定 *********/
		// int split = rect.width / width;// :倍率
		split = magnification;// :倍率

		System.out.println("split==" + split);
		/*****************/

		readImage.getRGB(0, 0, width, height, rgbArray, offset, scansize);// ここでRGBを全て取得する。

		for (int x = 0; x < width; x++) {
			// System.out.print(String.format("%1$2d", x));
		}

		System.out.println();

		for (int x = 0; x < width; x++) {
			// System.out.print(String.format("【%1$4d】 ", y));
			// System.out.println(" ");

			for (int y = 0; y < height; y++) {

				int pixel = rgbArray[(y * width) + x];// 現在位置のドット

				// System.out.println("rgbArray["+y+"*"+width+"+"+x+"]: "+rgbArray[y
				// * width + x]);

				// System.out.println("getRGB:"+c.getRGB()*(-1));
				// System.out.print(String.format("%1$9d", c.getRGB()));
				// System.out.print(String.format("%1$3d", c.getRed()));
				// System.out.print(" ");
				// System.out.print(String.format("%1$3d", c.getGreen()));
				// System.out.print(" ");
				// System.out.print(String.format("%1$3d", c.getBlue()));

				if (flag) {// 検索開始は白なので、黒を最初に検索開始

					// if (r < 50& g < 50 & b < 50)
					// {//黒に近いRGBInteger.toHexString(pixel)
					// if ((int)Integer.decode(Integer.toHexString(pixel))>
					// (int)Integer.decode("000000")) {//黒に近いRGB
					// if (c.getRed()==0&c.getBlue()==0&c.getGreen()==0) {//
					// 黒に近いRGBInteger.toHexString(pixel)
					if (pixel * (-1) > (Boundary_of_the_RGB_black_and_white * (-1))) {// 黒に近いRGBInteger.toHexString(pixel)

						brack_count++;

						// System.out.print(String.format("[%1$3d]",
						// brack_count));

						// System.out.print("黒");
					} else {

						non_brack_count++;

						// System.out.print(String.format("[%1$3d]",
						// non_brack_count));

						// System.out.print("白");
					}

					// System.out.print("");

					if (brack_count > (height * boundaries_of_the_percentage_of_RGB_white)) {// 黒行を発見（60％）

						// System.out.println();
						// System.out.println();
						// System.out.print("■brack_count:" + brack_count + "  "
						// + (int) brack_count * 100 / width + "％");
						//
						// System.out.print(" ■line_top_y:" + line_top_x
						// + " line_bottom_y:" + line_bottom_x);
						// System.out.println();

						// System.out.println(" 白行検索開始 brack_count："+brack_count+" y_top:"+y_top+" y_bottom:"+y_bottom);

						line_top_x = x - 1;// 検索結果の1行手前を、画像切り取りtopとする

						flag = false;// 黒行、文字列に入ったため、白行まで探索

						break;
					}

				} else {

					// if (c.getRed()==255&c.getBlue()==255&c.getGreen()==255) {
					if (pixel * (-1) < (Boundary_of_the_RGB_black_and_white * (-1))) {
						// if (r > 200 & g > 200 & b > 200) {//白に近いRGB
						// if ((int)Integer.decode(Integer.toHexString(pixel))<
						// (int)Integer.decode("000000")) {//白に近いRGB

						white_count++;

						// System.out.print(String.format("[%1$3d]",
						// white_count));

						// System.out.print("白");

					} else {
						non_white_count++;

						// System.out.print(String.format("[%1$3d]",
						// non_white_count));

						// System.out.print("黒");
					}

					// System.out.print("");

					if (white_count > height
							* boundaries_of_the_percentage_of_RGB_brack) {

						// System.out.println(" 黒行検索開始【切断】white_count："+white_count+" y_top:"+y_top+" y_bottom:"+y_bottom);

						// System.out.println();
						// System.out.println();
						// System.out.print("□white_count:" + white_count + "  "
						// + (int) white_count * 100 / width + "％");
						// System.out.print(" □line_top_x:" + line_top_x
						// + " line_bottom_x:" + line_bottom_x);
						// System.out.println();

						white_count = 0;
						non_white_count = 0;

						line_bottom_x = x + 2;

						/******** 分割→拡大 *******/

						for (int j = split, i = 1; i <= split; i++, j--) {

							// Zoom zoom = new Zoom(
							//
							// readImage, //
							// // ボタンに乗せる画像
							// 0, //
							// 0, //
							// width
							// + (rect.height - height
							// - scroleber_width - 55),// 55:スクロールペインのデフォルトバーの幅
							// (line_bottom_x * split - line_top_x * split)
							// * split,//
							//
							// // 元の画像
							// (int) (height - (height * (j / (double)
							// split))),// +(line_bottom_y-line_top_y):一文字かぶせる
							// line_top_x,//
							// (int) ((height * (i / (double) split))), //
							// line_bottom_x);

							System.out
									.println("--------------------------------");
							System.out.println("a:" + (double) rect.height
									/ height);
							System.out.println("a:" + (double) height);
							System.out.println("a:" + (double) rect.height);

							Zoom zoom = new Zoom(
									readImage, //
												// ボタンに乗せる画像
									0, //
									0, //
										// (line_bottom_x*split-line_top_x*split)*split,//
										// 55:スクロールペインのデフォルトバーの幅

									(int) ((int) ((line_bottom_x - line_top_x) * split)
											* (double) rect.height / height),

									rect.height - scrol_higth,//

									// 元の画像
									line_top_x,// +(line_bottom_y-line_top_y):一文字かぶせる
									(int) (height - (height * (i / (double) split)))
											- Integer.parseInt(kabuse_haba),//
									line_bottom_x,
									(int) ((height * (j / (double) split))) //
							);

							System.out.println(":"
									+ (line_bottom_x - line_top_x)
									* (rect.height / height * split));
							System.out.println((line_bottom_x - line_top_x));
							System.out.println((rect.height / height * split));

							/********* ソース画像サイズ **********/
							// System.out.print("ソース画像サイズ:");
							// System.out
							// .print(" sx："
							// + String.format(
							// "%1$2d",
							// (int) (width - (width * (j / (double) split)))));
							// System.out.print(" sy："
							// + String.format("%1$2d", line_top_x));
							// System.out
							// .print("　sw："
							// + String.format(
							// "%1$2d",
							// (int) ((width * (i / (double) split)))));
							// System.out.println(" sh："
							// + String.format("%1$2d", line_bottom_x));
							/*******************/

							/********* 表示画像サイズ **********/
							// System.out.print("表示画像サイズ　:");
							// System.out
							// .print(" sx：" + String.format("%1$2d", 0));
							// System.out
							// .print(" sy：" + String.format("%1$2d", 0));
							// System.out.print("　sw："
							// + String.format("%1$2d", width * split));
							// System.out.println(" sh："
							// + String.format("%1$2d", (line_bottom_x
							// * split - line_top_x * split)
							// * split));
							/*******************/

							// System.out.println();

							button = new JButton();

							// button.setPreferredSize(new Dimension(
							// (line_bottom_x * split - line_top_x * split)
							// * split, rect.height
							// - scroleber_width));
							//

							// Math.round((line_bottom_x-line_top_x)*(split)*rect.height/height)+5
							System.out
									.println("---------------------------------------------------------------");
							System.out
									.println((int) ((line_bottom_x - line_top_x) * split)
											* (double) rect.height / height);
							System.out.println((line_bottom_x - line_top_x)
									* (split));
							System.out.println(Math
									.round((line_bottom_x - line_top_x)));
							System.out.println(Math.round((split) * rect.height
									/ height));
							System.out.println(Math.round((split)
									* (double) rect.height / height));
							System.out.println((double) rect.height / height);

							int button_width = (int) ((int) ((line_bottom_x - line_top_x) * split)
									* (double) rect.height / height);

							button.setPreferredSize(new Dimension(
									button_width + 5, rect.height - scrol_higth));

							main_panel_width += button_width + 5 + 1;// ボタン幅の合計作成

							button.setMargin(new Insets(0, 0, 0, 0));
							button.setOpaque(true);
							button.setBorderPainted(false);
							button.setBackground(Color.white);
							button.add(zoom);
							main_panel.add(button);

							// main_panel_w +=
							// Math.round((line_bottom_x-line_top_x)*(split)*rect.height/height)+7;//
						}

						/********* 分割＼拡大end *********/

						flag = true;// 白行、文字列に入ったため、黒行まで探索

						break;
					}
				}

				// if(pixel<-60000){//白
				// System.out.print(String.format("%1$1d", 0));
				// }else{//黒
				// System.out.print(String.format("%1$1d", 1));
				// }
				// System.out.print("(" + x + "," + y + ")=" + pixel + " ");
				// System.out.print(String.format("%1$9d", pixel));

			}

			// if (blackCount == 64000) {
			// System.out.println("break y");
			// break; // loop y
			//
			// }

			// System.out
			// .print("/n                                                    【");
			// System.out.print(String.format("白検索(白%1$2d ", white_count));
			// System.out.print(String.format("黒%1$2d)", non_white_count));
			//
			// System.out.print(String.format("    黒検索(黒%1$2d ", brack_count));
			// System.out.print(String.format("白%1$2d)】", non_brack_count));

			white_count = 0;
			non_white_count = 0;

			brack_count = 0;
			non_brack_count = 0;

		}

		scrollpane = new JScrollPane(main_panel);
		scrollpane.getHorizontalScrollBar().setUnitIncrement(1000);
		scrollpane.setPreferredSize(new Dimension(rect.width, rect.height));

		// JScrollBar jScrollBar = new JScrollBar(JScrollBar.HORIZONTAL, 0, 10,
		// 0, 100);
		// jScrollBar.setPreferredSize(new Dimension(0,70 ));
		// jScrollBar.setBackground(Color.black);
		// jScrollBar.setForeground(Color.white);
		//
		//
		// jScrollBar.setBlockIncrement(rect.height - 200); //
		// 横ｽｸﾛｰﾙﾊﾞｰのつまみ("サム")をドラッグした場合の移動量
		// jScrollBar.setUnitIncrement(rect.height - 200); //
		// 横ｽｸﾛｰﾙﾊﾞｰの左右矢印ボタンをクリックした場合の移動量

		JViewport view = scrollpane.getViewport();
		// view.setViewPosition(new Point(rect.width* split * 15, 0));
		view.setViewPosition(new Point(rect.width * split * 15, 0));

		// scrollpane.setHorizontalScrollBar(jScrollBar);
		scrollpane
				.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);

		// int hBarMax = jScrollBar.getMaximum();
		// jScrollBar.setValue(hBarMax);

		control.addActionListener(this);

		this.setLayout(new BorderLayout());

		this.add(ctl_button_panel,BorderLayout.EAST);
		this.add(scrollpane, BorderLayout.CENTER);
		// this.add(control,BorderLayout.EAST);
		ImageIcon icon = new ImageIcon("./resource/img/tanzaku21.jpg");
		this.setIconImage(icon.getImage());
		this.setTitle(path + "【" + split + "倍】");

		// g.drawImage(readImage, 0, 50, pct_width*4, (y_bottom*4+50), 0, y_top,
		// pct_width, y_bottom-y_top
		// , this);

		this.setBounds(rect);
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);

		// System.out.println(Math.round((width*split)*(double)((double)rect.width/(double)width))+100);
		// System.out.println(Math.round((width*split)));
		// System.out.println(Math.round((rect.width/width)));
		// System.out.println((double)((double)rect.width/(double)width));
		// System.out.println((rect.width));
		// System.out.println((width));

		double yoko_hi = (double) ((double) rect.width / (double) width);// 画像とモニタの横比
		int main_frame_width = (int) Math.round((width * split) * yoko_hi) + 100;// メインパネル幅

		// main_panel.setPreferredSize(new
		// Dimension(Math.round((width*split)*(rect.height/height))+100, (int)
		// (rect.height-scrol_higth)));

		main_panel.setPreferredSize(new Dimension(main_panel_width,
				(int) (rect.height - scrol_higth)));
		main_panel.setBackground(Color.blue);

		System.out.println((main_frame_width));

		// main_panel.setAlignmentX(Component.RIGHT_ALIGNMENT);
		// main_panel.

		System.out.println("height * split::" + height * split * 15);

		this.setVisible(true);

		this.main_panel_width_int = this.main_panel_width;

		main_panel_width = 0;
	}

	public static void main(String[] args) throws Exception {

		// new tanzaku21_vertical_writing(
		// "C:/Users/Administrator.YAMAMOTO2-PC/Documents/4Videosoft Studio/4Videosoft Free PDF to JPEG Converter/Image/ロービジョンソフト要求仕様（写真）/ロービジョンソフト要求仕様（写真）0001.jpg",
		// 2);

		// new tanzaku21_vertical_writing(
		// "C:/11_workspace_timecard/tasuki21/vertial.jpg",
		// 2);

		// new vertical_writing(
		// //
		// "/Users/apple/Documents/workspace/tqnzaku21/Image/入江pdf/たて_1.png",//
		// "/Users/apple/Documents/workspace/tqnzaku21/Image/入江pdf/中学国文法0007.jpg",//
		// 10//
		// );

		new VerticalWriting(
		// "/Users/apple/Documents/workspace/tqnzaku21/Image/入江pdf/たて_1.png",//
				"C:/11_workspace_timecard/tasuki21/入江pdf/tate1.jpg",//
				10//
		);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		System.out.println("@@@@@-----");
		if(e.getActionCommand().equals("次"))
		{
			JViewport view = scrollpane.getViewport();
			if(view.getViewPosition().x > 0)
			{
				view.setViewPosition(new Point(view.getViewPosition().x - rect.width,0));
				System.out.println("------------------" + view.getViewPosition().x);
			}
		}
		else
		if(e.getActionCommand().equals("戻"))
		{
			JViewport view = scrollpane.getViewport();
			if(main_panel_width_int > view.getViewPosition().x)
			{
				view.setViewPosition(new Point(view.getViewPosition().x + rect.width,0));
				System.out.println("------------------" + view.getViewPosition().x);
			}
		}
		else
		if(e.getActionCommand().equals("頭"))
		{
			JViewport view = scrollpane.getViewport();
			view.setViewPosition(new Point(main_panel_width_int,0));
			System.out.println("-main_panel_width_int-----------------" + main_panel_width_int);
		}	}
}