package tanzaku;

import java.awt.Color;
import java.awt.Font;
import java.awt.GraphicsEnvironment;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;

import tanzaku.Dialog;
import tanzaku.Jpg_tate_renketu_;
import tanzaku.Straighten;

public class main_frame extends JFrame implements ActionListener {

	Properties prop = new Properties();

	GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
	Rectangle rect = env.getMaximumWindowBounds();

	JPanel pnael = new JPanel(new GridLayout(4, 1, 5, 5));

	JPanel btn_pnael = new JPanel(new GridLayout(1, 1, 5, 5));
	JPanel yokogaki_panel = new JPanel(new GridLayout(1, 20, 2, 2));

	JButton yokogaki_btns[] = new JButton[19];

	JPanel tategaki_panel = new JPanel(new GridLayout(1, 20, 2, 2));
	JButton tategaki_btns[] = new JButton[19];

	JButton katamuki_hosei_btn = new JButton("傾き修正");
	JButton gazou_ketugou_btn = new JButton("画像結合");

	JPanel kasanehab_panel = new JPanel(new GridLayout(4, 13, 1, 1));
	JButton kasanehab_btns[] = new JButton[50];

	int fontsize = 15;
	JMenuBar menuBar;
	JMenu menuFile;

	JMenu menuFile2;

	JMenuItem kabuse_haba;
	JMenuItem menuExit;

	JCheckBoxMenuItem[] h_top_haba = new JCheckBoxMenuItem[20];

	boolean white_brack;

	//String h_ue_haba = null;// 行の上幅

	public main_frame() {

		/*******************/
		Properties prop = new Properties();
		try {
			prop.load(new FileInputStream("./resource/prop1.properties"));
		} catch (FileNotFoundException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		} catch (IOException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		}

		pnael.setBackground(Color.blue);

		JButton btn = new JButton("<html>横書");
		btn.setBackground(Color.black);
		btn.setForeground(Color.white);
		btn.setOpaque(true);
		btn.setBorderPainted(false);

		yokogaki_panel.add(btn);

		white_brack = Boolean.parseBoolean(prop.getProperty("white_brack"));

		for (int j = 0; j < yokogaki_btns.length; j++) {

			yokogaki_btns[j] = new JButton("<html>" + (j + 2));

			if (white_brack) {
				yokogaki_btns[j].setBackground(Color.white);
				yokogaki_btns[j].setForeground(Color.black);
				yokogaki_btns[j].setOpaque(true);
				yokogaki_btns[j].setBorderPainted(false);
			} else {
				yokogaki_btns[j].setBackground(Color.black);
				yokogaki_btns[j].setForeground(Color.white);
				yokogaki_btns[j].setOpaque(true);
				yokogaki_btns[j].setBorderPainted(false);
			}

			yokogaki_btns[j].addActionListener(this);
			yokogaki_btns[j].setFont(new Font("", Font.BOLD, fontsize));
			yokogaki_btns[j].setMargin(new Insets(0, 0, 0, 0));
			yokogaki_panel.setBackground(Color.blue);
			yokogaki_panel.add(yokogaki_btns[j]);
		}

		JButton btn1 = new JButton("<html>縦書");
		btn1.setBackground(Color.black);
		btn1.setForeground(Color.white);
		btn1.setOpaque(true);
		btn1.setBorderPainted(false);

		tategaki_panel.add(btn1);

		for (int j = 0; j < tategaki_btns.length; j++) {
			tategaki_btns[j] = new JButton("<html>" + (j + 2));

			if (white_brack) {
				tategaki_btns[j].setBackground(Color.white);
				tategaki_btns[j].setForeground(Color.black);
				tategaki_btns[j].setOpaque(true);
				tategaki_btns[j].setBorderPainted(false);
			} else {
				tategaki_btns[j].setBackground(Color.black);
				tategaki_btns[j].setForeground(Color.white);
				tategaki_btns[j].setOpaque(true);
				tategaki_btns[j].setBorderPainted(false);
			}

			tategaki_btns[j].addActionListener(this);
			tategaki_btns[j].setFont(new Font("", Font.BOLD, fontsize));
			tategaki_btns[j].setMargin(new Insets(0, 0, 0, 0));
			tategaki_panel.setBackground(Color.blue);
			tategaki_panel.add(tategaki_btns[j]);
		}

		/*******************/
		JButton btn11 = new JButton("重幅");
		btn11.setBackground(Color.black);
		btn11.setForeground(Color.white);
		btn11.setOpaque(true);
		btn11.setBorderPainted(false);
		btn11.setFont(new Font("", Font.BOLD, fontsize));

		kasanehab_panel.add(btn11);

		for (int j = 0; j < kasanehab_btns.length; j++) {

			System.out.println("prop.getProperty(kabuse_haba):"
					+ prop.getProperty("kabuse_haba"));

			if (prop.getProperty("kabuse_haba").equals(String.valueOf((j + 1)))) {

				kasanehab_btns[j] = new JButton("" + (j + 1));
				kasanehab_btns[j].setBackground(Color.cyan);
				kasanehab_btns[j].setForeground(Color.darkGray);
				kasanehab_btns[j].setOpaque(true);
				kasanehab_btns[j].setBorderPainted(false);

				//
				// if (white_brack) {
				// kasanehab_btns[j].setBackground(Color.white);
				// kasanehab_btns[j].setForeground(Color.black);
				// } else {
				// kasanehab_btns[j].setBackground(Color.black);
				// kasanehab_btns[j].setForeground(Color.white);
				// }

				kasanehab_btns[j].addActionListener(this);
				kasanehab_btns[j]
						.setFont(new Font("", Font.BOLD, fontsize - 5));
				kasanehab_btns[j].setMargin(new Insets(0, 0, 0, 0));
				kasanehab_panel.setBackground(Color.blue);
				kasanehab_panel.add(kasanehab_btns[j]);

			} else {

				kasanehab_btns[j] = new JButton("" + (j + 1));

				if (white_brack) {
					kasanehab_btns[j].setBackground(Color.white);
					kasanehab_btns[j].setForeground(Color.black);
					kasanehab_btns[j].setOpaque(true);
					kasanehab_btns[j].setBorderPainted(false);

				} else {
					kasanehab_btns[j].setBackground(Color.black);
					kasanehab_btns[j].setForeground(Color.white);
					kasanehab_btns[j].setOpaque(true);
					kasanehab_btns[j].setBorderPainted(false);

				}

				kasanehab_btns[j].addActionListener(this);
				kasanehab_btns[j]
						.setFont(new Font("", Font.BOLD, fontsize - 5));
				kasanehab_btns[j].setMargin(new Insets(0, 0, 0, 0));
				kasanehab_panel.setBackground(Color.blue);
				kasanehab_panel.add(kasanehab_btns[j]);
			}
		}

		katamuki_hosei_btn.setBackground(Color.white);
		katamuki_hosei_btn.setFont(new Font("", Font.BOLD, fontsize));
		katamuki_hosei_btn.addActionListener(this);

		if (white_brack) {
			katamuki_hosei_btn.setBackground(Color.white);
			katamuki_hosei_btn.setForeground(Color.black);
			katamuki_hosei_btn.setOpaque(true);
			katamuki_hosei_btn.setBorderPainted(false);

		} else {
			katamuki_hosei_btn.setBackground(Color.black);
			katamuki_hosei_btn.setForeground(Color.white);
			katamuki_hosei_btn.setOpaque(true);
			katamuki_hosei_btn.setBorderPainted(false);

		}

		gazou_ketugou_btn.setBackground(Color.white);
		gazou_ketugou_btn.setFont(new Font("", Font.BOLD, fontsize));
		gazou_ketugou_btn.addActionListener(this);

		pnael.add(yokogaki_panel);
		pnael.add(tategaki_panel);
		pnael.add(kasanehab_panel);
		btn_pnael.add(katamuki_hosei_btn);
		// btn_pnael.add(gazou_ketugou_btn);

		btn_pnael.setBackground(Color.blue);

		pnael.add(btn_pnael);

		/********************/
		menuBar = new JMenuBar();
		menuFile = new JMenu("File");
		menuFile.setFont(new Font("", Font.BOLD, fontsize));

		menuFile2 = new JMenu("行間設定");
		menuFile2.setFont(new Font("", Font.BOLD, fontsize));
		menuFile2.addActionListener(this);

		kabuse_haba = new JMenuItem("白黒反転(o)");
		menuExit = new JMenuItem("exit(x)");
		kabuse_haba.setFont(new Font("", Font.BOLD, fontsize));
		menuExit.setFont(new Font("", Font.BOLD, fontsize));

		menuFile.setMnemonic('F');
		kabuse_haba.setMnemonic('O');
		menuExit.setMnemonic('x');

		for (int i = 0; i < h_top_haba.length; i++) {

			if (String.valueOf(i).equals(prop.getProperty("h_ue_haba"))) {

				h_top_haba[i] = new JCheckBoxMenuItem(String.valueOf(i), true);
				menuFile2.add(h_top_haba[i]);
				h_top_haba[i].addActionListener(this);

			} else {

				h_top_haba[i] = new JCheckBoxMenuItem(String.valueOf(i), false);
				menuFile2.add(h_top_haba[i]);
				h_top_haba[i].addActionListener(this);
			}

		}

		kabuse_haba.addActionListener(this);
		menuExit.addActionListener(this);

		getRootPane().setJMenuBar(menuBar);

		menuFile.add(kabuse_haba);
		menuFile.add(menuExit);

		menuBar.add(menuFile);
		menuBar.add(menuFile2); // 行間設定
		/********************/

		this.add(pnael);

		ImageIcon icon = new ImageIcon("./resource/img/tanzaku21.jpg");
		this.setIconImage(icon.getImage());
		this.setTitle("短冊／tanzaku");
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setBounds(0, 0, rect.width, 400);
		this.setVisible(true);
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see
	 * java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	/*
	 * (non-Javadoc)
	 *
	 * @see
	 * java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	/*
	 * (non-Javadoc)
	 *
	 * @see
	 * java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	/*
	 * (non-Javadoc)
	 *
	 * @see
	 * java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	@Override
	public void actionPerformed(ActionEvent e) {

		try {
			prop.load(new FileInputStream("./resource/prop1.properties"));
		} catch (FileNotFoundException e1) {

			e1.printStackTrace();
		} catch (IOException e1) {

			e1.printStackTrace();
		}

		String katamukihosei_path = prop.getProperty("closing_path");
		// System.out.println("closing_path:" + katamukihosei_path);

		String gazouketugou_path = prop.getProperty("gazouketugou_path");
		// System.out.println("gazouketugou_path:" + gazouketugou_path);

		for (int j = 0; j < h_top_haba.length; j++) {
			h_top_haba[j].setState(false);

			if (e.getSource() == h_top_haba[j]) {
				try {
					prop.load(new FileInputStream("./resource/prop1.properties"));
				} catch (FileNotFoundException e1) {
					// TODO 自動生成された catch ブロック
					e1.printStackTrace();
				} catch (IOException e1) {
					// TODO 自動生成された catch ブロック
					e1.printStackTrace();
				}

				// prop.getProperty("h_ue_haba");

				prop.setProperty("h_ue_haba", h_top_haba[j].getText());
				System.out.println("h_top_haba[j].getText()=="
						+ h_top_haba[j].getText());

				h_top_haba[j].setState(true);

				try {
					prop.store(new FileOutputStream(
							"./resource/prop1.properties"), "prop1");
				} catch (FileNotFoundException e1) {
					// TODO 自動生成された catch ブロック
					e1.printStackTrace();
				} catch (IOException e1) {
					// TODO 自動生成された catch ブロック
					e1.printStackTrace();
				}
			}

		}

		if (e.getSource() == kabuse_haba) {

			// System.out.println("kabuse_haba==" + kabuse_haba);
			// System.out.println("prop.getProperty(white_brack)==" +
			// prop.getProperty("white_brack"));

			if (prop.getProperty("white_brack").equals("true")) {

				prop.setProperty("white_brack", "false");

				try {
					prop.store(new FileOutputStream(
							"./resource/prop1.properties"), "prop1");
				} catch (FileNotFoundException e1) {
					// TODO 自動生成された catch ブロック
					e1.printStackTrace();
				} catch (IOException e1) {
					// TODO 自動生成された catch ブロック
					e1.printStackTrace();
				}
			} else {
				prop.setProperty("white_brack", "true");

				try {
					prop.store(new FileOutputStream(
							"./resource/prop1.properties"), "prop1");
				} catch (FileNotFoundException e1) {
					// TODO 自動生成された catch ブロック
					e1.printStackTrace();
				} catch (IOException e1) {
					// TODO 自動生成された catch ブロック
					e1.printStackTrace();
				}
			}

			if (Boolean.parseBoolean(prop.getProperty("white_brack"))) {
				katamuki_hosei_btn.setBackground(Color.white);
				katamuki_hosei_btn.setForeground(Color.black);
				katamuki_hosei_btn.setOpaque(true);
				katamuki_hosei_btn.setBorderPainted(false);

				for (int j = 0; j < yokogaki_btns.length; j++) {
					yokogaki_btns[j].setBackground(Color.white);
					yokogaki_btns[j].setForeground(Color.black);
					yokogaki_btns[j].setOpaque(true);
					yokogaki_btns[j].setBorderPainted(false);
				}
				for (int j = 0; j < tategaki_btns.length; j++) {
					tategaki_btns[j].setBackground(Color.white);
					tategaki_btns[j].setForeground(Color.black);
					yokogaki_btns[j].setOpaque(true);
					yokogaki_btns[j].setBorderPainted(false);
				}
				for (int j = 0; j < kasanehab_btns.length; j++) {
					if (prop.getProperty("kabuse_haba").equals(
							String.valueOf((j + 1)))) {

						kasanehab_btns[j].setBackground(Color.cyan);
						kasanehab_btns[j].setForeground(Color.black);
						kasanehab_btns[j].setOpaque(true);
						kasanehab_btns[j].setBorderPainted(false);
					} else {

						kasanehab_btns[j].setBackground(Color.white);
						kasanehab_btns[j].setForeground(Color.black);
						kasanehab_btns[j].setOpaque(true);
						kasanehab_btns[j].setBorderPainted(false);
					}
				}
			} else {
				katamuki_hosei_btn.setBackground(Color.black);
				katamuki_hosei_btn.setForeground(Color.white);
				katamuki_hosei_btn.setOpaque(true);
				katamuki_hosei_btn.setBorderPainted(false);

				for (int j = 0; j < yokogaki_btns.length; j++) {
					yokogaki_btns[j].setBackground(Color.black);
					yokogaki_btns[j].setForeground(Color.white);
					yokogaki_btns[j].setOpaque(true);
					yokogaki_btns[j].setBorderPainted(false);
				}
				for (int j = 0; j < tategaki_btns.length; j++) {
					tategaki_btns[j].setBackground(Color.black);
					tategaki_btns[j].setForeground(Color.white);
					tategaki_btns[j].setOpaque(true);
					tategaki_btns[j].setBorderPainted(false);
				}
				for (int j = 0; j < kasanehab_btns.length; j++) {

					if (prop.getProperty("kabuse_haba").equals(
							String.valueOf((j + 1)))) {

						kasanehab_btns[j].setBackground(Color.cyan);
						kasanehab_btns[j].setForeground(Color.black);
						kasanehab_btns[j].setOpaque(true);
						kasanehab_btns[j].setBorderPainted(false);

					} else {
						kasanehab_btns[j].setBackground(Color.black);
						kasanehab_btns[j].setForeground(Color.white);
						kasanehab_btns[j].setOpaque(true);
						kasanehab_btns[j].setBorderPainted(false);
					}
				}

			}

			this.setVisible(true);

		}

		for (int i = 0; i < kasanehab_btns.length; i++) {

			if (kasanehab_btns[i] == e.getSource()) {

				// System.out.println("if(menuOpen == e.getSource())");
				//
				// System.out.println("actioncomand: " +
				// kasanehab_btns[i].getActionCommand());

				try {
					prop.load(new FileInputStream("./resource/prop1.properties"));
				} catch (FileNotFoundException e1) {
					// TODO 自動生成された catch ブロック
					e1.printStackTrace();
				} catch (IOException e1) {
					// TODO 自動生成された catch ブロック
					e1.printStackTrace();
				}

				prop.setProperty("kabuse_haba",
						kasanehab_btns[i].getActionCommand());

				try {
					prop.store(new FileOutputStream(
							"./resource/prop1.properties"), "prop1");
				} catch (FileNotFoundException e1) {
					// TODO 自動生成された catch ブロック
					e1.printStackTrace();
				} catch (IOException e1) {
					// TODO 自動生成された catch ブロック
					e1.printStackTrace();
				}

				/*******************/
				Properties prop = new Properties();
				try {
					prop.load(new FileInputStream("./resource/prop1.properties"));
				} catch (FileNotFoundException e1) {
					// TODO 自動生成された catch ブロック
					e1.printStackTrace();
				} catch (IOException e1) {
					// TODO 自動生成された catch ブロック
					e1.printStackTrace();
				}

				for (int j = 0; j < kasanehab_btns.length; j++) {

					System.out.println("prop.getProperty(kabuse_haba):"
							+ prop.getProperty("kabuse_haba"));

					if (prop.getProperty("kabuse_haba").equals(
							String.valueOf((j + 1)))) {

						kasanehab_btns[j].setBackground(Color.cyan);
						kasanehab_btns[j].setForeground(Color.black);
						kasanehab_btns[j].setOpaque(true);
						kasanehab_btns[j].setBorderPainted(false);

						kasanehab_btns[j].addActionListener(this);
						kasanehab_btns[j].setFont(new Font("", Font.BOLD,
								fontsize - 5));
						kasanehab_btns[j].setMargin(new Insets(0, 0, 0, 0));
						kasanehab_panel.setBackground(Color.blue);

					} else {

						if (Boolean.parseBoolean(prop
								.getProperty("white_brack"))) {

							kasanehab_btns[j].setBackground(Color.white);
							kasanehab_btns[j].setForeground(Color.black);
							kasanehab_btns[j].setOpaque(true);
							kasanehab_btns[j].setBorderPainted(false);

							kasanehab_btns[j].addActionListener(this);
							kasanehab_btns[j].setFont(new Font("", Font.BOLD,
									fontsize - 5));
							kasanehab_btns[j].setMargin(new Insets(0, 0, 0, 0));
							kasanehab_panel.setBackground(Color.blue);

						} else {
							kasanehab_btns[j].setBackground(Color.black);
							kasanehab_btns[j].setForeground(Color.white);
							kasanehab_btns[j].setOpaque(true);
							kasanehab_btns[j].setBorderPainted(false);

							kasanehab_btns[j].addActionListener(this);
							kasanehab_btns[j].setFont(new Font("", Font.BOLD,
									fontsize - 5));
							kasanehab_btns[j].setMargin(new Insets(0, 0, 0, 0));
							kasanehab_panel.setBackground(Color.blue);
						}

					}
				}

				this.setVisible(true);

				// new set();
			}
		}

		/**************************** menu ***********************************/
		if (menuExit == e.getSource()) {

			// System.out.println("if(menuExit == e.getSource())");

			System.exit(0);
		}

		for (int i = 0; i < yokogaki_btns.length; i++) {
			/************************** 横書き *********************************/
			if (e.getSource() == yokogaki_btns[i]) {

				JFileChooser filechooser = new JFileChooser(katamukihosei_path);

				// System.out.println("test");

				int selected = filechooser.showOpenDialog(this);

				/********* 行の上幅の再設定 ***********/
				for (int i1 = 0; i1 < h_top_haba.length; i1++) {

					if (String.valueOf(i1)
							.equals(prop.getProperty("h_ue_haba"))) {

						h_top_haba[i1].setState(true);

					} else {

						h_top_haba[i1].setState(false);
					}

				}

				if (selected == JFileChooser.APPROVE_OPTION) {

					File file = filechooser.getSelectedFile();

					new HorizontalWriting(file.getAbsolutePath(), i + 2);

					prop.setProperty("closing_path", file.getAbsoluteFile()
							.getAbsolutePath());
					try {
						prop.store(new FileOutputStream(
								"./resource/prop1.properties"), "prop1");
					} catch (FileNotFoundException e1) {
						e1.printStackTrace();
					} catch (IOException e1) {
						e1.printStackTrace();
					}

				} else if (selected == JFileChooser.CANCEL_OPTION) {

					System.out.println("キャンセルされました");
				} else if (selected == JFileChooser.ERROR_OPTION) {

					System.out.println("エラー又は取消しがありました");
				}

			}
		}

		for (int i = 0; i < tategaki_btns.length; i++) {
			/************************** 縦書き *********************************/
			if (e.getSource() == tategaki_btns[i]) {
				JFileChooser filechooser = new JFileChooser(katamukihosei_path);

				// System.out.println("test");

				int selected = filechooser.showOpenDialog(this);

				if (selected == JFileChooser.APPROVE_OPTION) {
					File file = filechooser.getSelectedFile();
					//
					// System.out.println(file.getAbsolutePath());

					new VerticalWriting(file.getAbsolutePath(), i + 2);

					prop.setProperty("closing_path", file.getAbsoluteFile()
							.getAbsolutePath());
					try {
						prop.store(new FileOutputStream(
								"./resource/prop1.properties"), "prop1");
					} catch (FileNotFoundException e1) {
						e1.printStackTrace();
					} catch (IOException e1) {
						e1.printStackTrace();
					}

				} else if (selected == JFileChooser.CANCEL_OPTION) {

					System.out.println("キャンセルされました");
				} else if (selected == JFileChooser.ERROR_OPTION) {

					System.out.println("エラー又は取消しがありました");
				}

			}
		}
		if (e.getSource() == katamuki_hosei_btn) {

			JFileChooser filechooser = new JFileChooser(katamukihosei_path);

			// System.out.println("test");

			int selected = filechooser.showOpenDialog(this);

			if (selected == JFileChooser.APPROVE_OPTION) {
				File file = filechooser.getSelectedFile();

				new Straighten(file.getAbsolutePath());

				prop.setProperty("closing_path", file.getAbsoluteFile()
						.getAbsolutePath());
				try {
					prop.store(new FileOutputStream(
							"./resource/prop1.properties"), "prop1");
				} catch (FileNotFoundException e1) {
					e1.printStackTrace();
				} catch (IOException e1) {
					e1.printStackTrace();
				}
			} else if (selected == JFileChooser.CANCEL_OPTION) {

				System.out.println("キャンセルされました");
			} else if (selected == JFileChooser.ERROR_OPTION) {

	 			System.out.println("エラー又は取消しがありました");
			}
		} else if (e.getSource() == gazou_ketugou_btn) {

			JFileChooser filechooser = new JFileChooser(gazouketugou_path);
			filechooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

			int selected = filechooser.showOpenDialog(this);

			if (selected == JFileChooser.APPROVE_OPTION) {

				File file = filechooser.getSelectedFile();
				try {

					File[] files = file.listFiles();
					// System.out.println("files.length==" + files.length);

					int f = Jpg_tate_renketu_.jpg_ketugou(//
							file.getAbsolutePath() + "/" + files[0].getName()//
							, file.getAbsolutePath()//
							, files[0].getName()//
							, 1//
							, files.length + 1//
							);

					if (1 == f) {
						new Dialog("完了", "完了しました。", 3);
					} else if (2 == f) {
						new Dialog("エラー", "ファイルエラー", 2);
					}

				} catch (IOException e2) {
					e2.printStackTrace();
				}

				prop.setProperty("gazouketugou_path", file.getAbsoluteFile()
						.getAbsolutePath());
				try {
					prop.store(new FileOutputStream(
							"./resource/prop1.properties"), "prop1");
				} catch (FileNotFoundException e1) {
					e1.printStackTrace();
				} catch (IOException e1) {
					e1.printStackTrace();
				}
			} else if (selected == JFileChooser.CANCEL_OPTION) {

				System.out.println("キャンセルされました");
			} else if (selected == JFileChooser.ERROR_OPTION) {

				System.out.println("エラー又は取消しがありました");
			}
		}
	}

	public static void main(String a[]) {
		new main_frame();
	}
}
